From 08f4aeaff6bbc1bde65554c851d4b3da626cb3aa Mon Sep 17 00:00:00 2001
From: Amit Langote <amitlan@postgresql.org>
Date: Thu, 25 Jun 2026 08:13:28 +0900
Subject: [PATCH v3] Avoid ABI break in ModifyTableState from the FDW pruning
 fix

Commit 1ef917e3a6 fixed the re-indexing of ModifyTable's FDW arrays
when initial runtime pruning removes result relations, but it did so
by adding a new mt_fdwPrivLists field to ModifyTableState.  Although
the field was placed at the end of the struct to keep the offsets of
existing fields stable, it still enlarges sizeof(ModifyTableState),
which the ABI compliance check flags on the buildfarm (e.g. crake).

The field existed only so that show_modifytable_info() could recover the
re-indexed fdw_private after executor startup; the executor-side fix in
ExecInitModifyTable() that actually prevents the crash does not depend on
it.  Remove the field and have show_modifytable_info() instead look up
each kept relation's fdw_private from the original, pre-pruning
node->fdwPrivLists, which is parallel to node->resultRelations and left
intact by pruning.  When nothing was pruned the lookup is a direct index;
otherwise it matches on the range table index.

This is applied to REL_18 only; master keeps the mt_fdwPrivLists field
and is unaffected, so the two diverge slightly here.

Reported on the buildfarm (member crake).

Per a suggestion from Tom Lane.

Reviewed-by: Etsuro Fujita <etsuro.fujita@gmail.com>
Discussion: https://postgr.es/m/CA+HiwqEhe7-v5Q0-oOoW3RaO4voYcGK-JfinbYEWXwutDGSOtQ@mail.gmail.com
---
 src/backend/commands/explain.c         | 36 +++++++++++++++++++++++++-
 src/backend/executor/nodeModifyTable.c |  1 -
 src/include/nodes/execnodes.h          |  8 +++---
 3 files changed, 38 insertions(+), 7 deletions(-)

diff --git a/src/backend/commands/explain.c b/src/backend/commands/explain.c
index 6d2624e75b8..15ef3304863 100644
--- a/src/backend/commands/explain.c
+++ b/src/backend/commands/explain.c
@@ -4524,6 +4524,7 @@ show_modifytable_info(ModifyTableState *mtstate, List *ancestors,
 	const char *operation;
 	const char *foperation;
 	bool		labeltargets;
+	bool		nopruning;
 	int			j;
 	List	   *idxNames = NIL;
 	ListCell   *lst;
@@ -4571,6 +4572,16 @@ show_modifytable_info(ModifyTableState *mtstate, List *ancestors,
 	if (labeltargets)
 		ExplainOpenGroup("Target Tables", "Target Tables", false, es);
 
+	/*
+	 * node->fdwPrivLists is parallel to node->resultRelations, in the
+	 * original pre-pruning order.  If no result relations were pruned, the
+	 * entries in mtstate->resultRelInfo[] are in that same order and can be
+	 * matched to fdwPrivLists positionally; otherwise we have to look each
+	 * one up by range table index below.  This test is loop-invariant, so
+	 * compute it once here.
+	 */
+	nopruning = (list_length(node->resultRelations) == mtstate->mt_nrels);
+
 	for (j = 0; j < mtstate->mt_nrels; j++)
 	{
 		ResultRelInfo *resultRelInfo = mtstate->resultRelInfo + j;
@@ -4609,7 +4620,30 @@ show_modifytable_info(ModifyTableState *mtstate, List *ancestors,
 			fdwroutine != NULL &&
 			fdwroutine->ExplainForeignModify != NULL)
 		{
-			List	   *fdw_private = (List *) list_nth(mtstate->mt_fdwPrivLists, j);
+			List	   *fdw_private;
+
+			/*
+			 * Find this relation's fdw_private: index fdwPrivLists directly
+			 * when nothing was pruned, else match by range table index.
+			 */
+			if (nopruning)
+				fdw_private = (List *) list_nth(node->fdwPrivLists, j);
+			else
+			{
+				Index		rti = resultRelInfo->ri_RangeTableIndex;
+				ListCell   *lc1;
+				ListCell   *lc2;
+
+				fdw_private = NIL;
+				forboth(lc1, node->resultRelations, lc2, node->fdwPrivLists)
+				{
+					if (lfirst_int(lc1) == (int) rti)
+					{
+						fdw_private = (List *) lfirst(lc2);
+						break;
+					}
+				}
+			}
 
 			fdwroutine->ExplainForeignModify(mtstate,
 											 resultRelInfo,
diff --git a/src/backend/executor/nodeModifyTable.c b/src/backend/executor/nodeModifyTable.c
index cac30666663..7c1d0e9588e 100644
--- a/src/backend/executor/nodeModifyTable.c
+++ b/src/backend/executor/nodeModifyTable.c
@@ -4770,7 +4770,6 @@ ExecInitModifyTable(ModifyTable *node, EState *estate, int eflags)
 	mtstate->mt_updateColnosLists = updateColnosLists;
 	mtstate->mt_mergeActionLists = mergeActionLists;
 	mtstate->mt_mergeJoinConditions = mergeJoinConditions;
-	mtstate->mt_fdwPrivLists = fdwPrivLists;
 
 	/*----------
 	 * Resolve the target relation. This is the same as:
diff --git a/src/include/nodes/execnodes.h b/src/include/nodes/execnodes.h
index 6677a03caab..409e172bfb6 100644
--- a/src/include/nodes/execnodes.h
+++ b/src/include/nodes/execnodes.h
@@ -1453,15 +1453,13 @@ typedef struct ModifyTableState
 	double		mt_merge_deleted;
 
 	/*
-	 * Lists of valid updateColnosLists, mergeActionLists,
-	 * mergeJoinConditions, and fdwPrivLists.  These contain only entries for
-	 * unpruned relations, filtered from the corresponding lists in
-	 * ModifyTable.
+	 * Lists of valid updateColnosLists, mergeActionLists, and
+	 * mergeJoinConditions.  These contain only entries for unpruned
+	 * relations, filtered from the corresponding lists in ModifyTable.
 	 */
 	List	   *mt_updateColnosLists;
 	List	   *mt_mergeActionLists;
 	List	   *mt_mergeJoinConditions;
-	List	   *mt_fdwPrivLists;
 } ModifyTableState;
 
 /* ----------------
-- 
2.47.3

